import { SelectorsOf, ReducerOf, EffectsOf, ActionsOf, DefaultReducer } from '../types/common';
import { KopContainerModule } from '../types/containerModule';
export default function createContainerModule<State = {}, Selectors extends SelectorsOf<State> = SelectorsOf<State>, Reducers extends ReducerOf<State> = ReducerOf<State>, Effects = {}, ActionCreators = {}>(namespace: string, pkg: {
    initialState?: State;
    selectors?: Selectors;
    reducers?: Reducers;
    defaultReducer?: DefaultReducer<State>;
    effects?: EffectsOf<Selectors, Reducers, Effects>;
    effectLoading?: boolean;
    actionCreators?: ActionsOf<ActionCreators, Reducers, Effects, Selectors>;
}): KopContainerModule<Selectors, Reducers, Effects, ActionCreators>;
