import { SelectorsOf, ReducerOf, EffectsOf, ActionsOf } from '../types/common';
import { KopGlobalModule } from '../types/globalModule';
export default function createGlobalModule<State = {}, Selectors extends SelectorsOf<State> = SelectorsOf<State>, Reducers extends ReducerOf<State> = ReducerOf<State>, Effects = {}, ActionCreators = {}>(namespace: string, pkg: {
    initialState?: State;
    selectors?: Selectors;
    reducers?: Reducers;
    effects?: EffectsOf<Selectors, Reducers, Effects>;
    effectLoading?: boolean;
    actionCreators?: ActionsOf<ActionCreators, Reducers, Effects, Selectors>;
}): KopGlobalModule<Selectors, Reducers, Effects, ActionCreators>;
