import { SelectorsOf, ReducerOf, ActionsOf, DefaultReducer } from '../types/common';
import { PageEffectsOf, KopPageModule } from '../types/pageModule';
import { KopContainerModule } from '../types/containerModule';
interface PageOptions<State, Selectors, Reducers, Effects, Watchers, ActionCreators> {
    initialState?: State;
    selectors?: Selectors;
    reducers?: Reducers;
    defaultReducer?: DefaultReducer<State>;
    injectModules?: KopContainerModule<{}, {}, {}, {}>[];
    effects?: PageEffectsOf<Selectors, Reducers, Effects>;
    watchers?: PageEffectsOf<Selectors, Reducers, Watchers>;
    effectLoading?: boolean;
    actionCreators?: ActionsOf<ActionCreators, Reducers, Effects, Selectors>;
}
export default function createPageModule<State, Selectors extends SelectorsOf<State> = SelectorsOf<State>, Reducers extends ReducerOf<State> = ReducerOf<State>, Effects = {}, Watchers = {}, ActionCreators = {}>(namespace: string, pkg: PageOptions<State, Selectors, Reducers, Effects, Watchers, ActionCreators>): KopPageModule<Selectors, Reducers, Effects, ActionCreators>;
export {};
